#
# Settings.pm
#
#  make all settings changes in here. see the "edit below" section.
#

package Settings;

use Exporter;
@ISA    = qw ( Exporter );
@EXPORT = qw ( settings_get );

sub settings_get  {

  #
  # edit below
  #######################################################################

  $display_type = "vfd";       # one of the following:
                               # crystalfontz - CrystalFontz Display
                               #          lcd - liquid crystal display
                               #          vfd - vaccuum florescent display
                               #      console - system console


  $serial_port  = "/dev/ttyS1"; # usually "/dev/ttyS0" or "/dev/ttyS1" 
                                # (ignored if display_type is console.)


  if ($display_type eq "console" || $display_type eq "crystalfontz" ) {
    $up_key       = "a";
    $forward_key  = ".";
    $down_key     = "z";
    $back_key     = ",";

  } else {
    $up_key       = "D";
    $forward_key  = "C";
    $down_key     = "A";
    $back_key     = "B";

  }    

  $radio_pass_thru= 0;     # Percent value of Line Level Volume:
                           # Use if your Radio passes into the Line
                           # input on your soundcard. Otherwise, disable (0)

  $menu_scrolling = "marquee";       # Menu Scroll Mode: marquee or bounce
  $setvol_cmd     = "/usr/bin/aumix";
  $halt_cmd       = "/bin/sync; /sbin/halt";

  #######################################################################
  # end editable section
  #

  return ( $display_type, $serial_port, 
           $up_key, $down_key, $forward_key, $back_key, 
           $setvol_cmd, $menu_scrolling, $radio_pass_thru, $halt_cmd );

}
