#!/usr/bin/perl

#
# edit tool for route66 web based database manipulation tool
#
#   by anders brownworth - anders-route66@evantide.com
#

use Database;
use Web;

print "Content-type: text/html\n\n";

( $dbh, $version ) = database_open ();

cgi_parse();

if ( $cgi{'type'} eq "artists" )  {
  if ( $cgi{'update'} eq "yes" )  {
    $artistid = database_get_artistid ( $dbh, $cgi{'artist_origional'} );
    if ( $artistid ne "" )  {
      database_update_artist ( $dbh, $artistid, $cgi{'artist'} ) unless 
                  ( $cgi{'artist_origional'} eq $cgi{'artist'} );
      print "<html><script language=javascript>\n";
      print "window.opener.location.href=\"show_like.cgi?type=artists&query=$cgi{'query'}\";\n";
      print "self.window.close();\n";
      print "</script></html>\n";

    }
    else  {
      print "couldn't find artistid for [$cgi{'name_origional'}]. not updated\n";

    }

  }
  else  {
    print inject_vars ( "templates/edit_artist.inc", 
		"artist",	$cgi{'name'} );

  }

}
elsif ( $cgi{'type'} eq "albums" )  {
  if ( $cgi{'update'} eq "yes" )  {
    $albumid = database_get_albumid ( $dbh, $cgi{'album_origional'} );
    if ( $albumid ne "" )  {
      database_update_album ( $dbh, $albumid, $cgi{'artistid'}, $cgi{'album'}, $cgi{'year'} );
      print "<html><script language=javascript>\n";
      print "window.opener.location.href=\"show_like.cgi?type=albums&query=$cgi{'query'}\";\n";
      print "self.window.close();\n";
      print "</script></html>\n";

    }
    else  {
      print "couldn't find albumid for [$cgi{'album_origional'}]. not updated\n";

    }

  }
  else  {
    $albumid = database_get_albumid ( $dbh, $cgi{'name'} );
    ( $artistid, $album, $year ) = database_get_album ( $dbh, $albumid );
    @artists = database_get_all_artists ( $dbh );

    foreach $key ( sort @artists )  {
      $id = database_get_artistid ( $dbh, $key );
      if ( $id == $artistid )  {
        $artist_html .= "<option selected value=\"$id\">$key</option>\n";

      }
      else  {
        $artist_html .= "<option value=\"$id\">$key</option>\n";

      }

    }
    print inject_vars ( "templates/edit_album.inc",
		"artist_html",	$artist_html,
		"year",		$year,
                "album",	$cgi{'name'} );

  }

}
elsif ( $cgi{'type'} eq "genres" )  {
  if ( $cgi{'update'} eq "yes" )  {
    $genreid = database_get_genreid ( $dbh, $cgi{'genre_origional'} );
    if ( $genreid ne "" )  {
      database_update_genre ( $dbh, $genreid, $cgi{'genre'} );
      print "<html><script language=javascript>\n";
      print "window.opener.location.href=\"show.cgi?type=genres\";\n";
      print "self.window.close();\n";
      print "</script></html>\n";

    }
    else  {
      print "couldn't find genreid for [$cgi{'genre_origional'}]. not updated\n";

    }

  }
  else  {
    print inject_vars ( "templates/edit_genre.inc",
		"genre",	$cgi{'name'} );

  }

}
elsif ( $cgi{'type'} eq "songs" )  {
  if ( $cgi{'update'} eq "yes" )  {
    $songid = database_get_songid_from_song ( $dbh, $cgi{'song_origional'} );
    if ( $songid ne "" )  {
      database_update_song ( $dbh, $songid, $cgi{'song'} );
      print "<html><script language=javascript>\n";
      print "window.opener.location.href=\"show_like.cgi?type=songs&query=$cgi{'query'}\";\n";
      print "self.window.close();\n";
      print "</script></html>\n";
   
    }
    else  {
      print "couldn't find songid for [$cgi{'song_origional'}]. not updated\n";

    }

  }
  else  {
    print inject_vars ( "templates/edit_song.inc",
                "song",        $cgi{'name'} );

  }

}
else  {
  print "cgi [$cgi{'type'}] not handled in this script\n";

}
