#!/usr/bin/perl

#
# insert tool for route66 web based database manipulation tool
#
#   by anders brownworth - anders-route66@evantide.com
#

use Database;
use Web;
use MP3::Info;

print "Content-type: text/html\n\n";

( $dbh, $version ) = database_open ();

cgi_parse();

if ( $cgi{'file'} ne "" )  {
  $tag = get_mp3tag($cgi{'file'});

  $title_default = $tag->{TITLE};
  $artist_default = $tag->{ARTIST};
  $album_default = $tag->{ALBUM};
  $genre_default = $tag->{GENRE};
  $year_default = $tag->{YEAR};
  $track_default = "0";

  if ( $title_default eq "" )  {
    $title_default = "";

  }
  if ( $artist_default eq "" )  {
    $artist_default = "";

  }
  if ( $album_default eq "" )  {
    $album_default = "";

  }
  if ( $genre_default eq "" )  {
    $genre_default = "Rock";

  }
  if ( $year_default eq "" )  {
    $year_default = "2000";

  }
  @paths = split /\//, $cgi{'file'};

  foreach $path ( @paths )  {
    $path = capitalize ( $path );
    $title_list .= "<a href=\"javascript:select('title','$path');\">$path</a><br>\n"
        unless ( $path eq "" );
    $artist_list .= "<a href=\"javascript:select('artist','$path');\">$path</a><br>\n"
        unless ( $path eq "" );
    $album_list .= "<a href=\"javascript:select('album','$path');\">$path</a><br>\n"
        unless ( $path eq "" );
  }

  @genres = database_get_all_genres ( $dbh );

  foreach $genre ( @genres )  {
    $genre_list .= "<a href=\"javascript:select('genre','$genre');\">$genre</a><br>\n";

  }

  for ( $x=1960; $x < 2000; $x = $x + 5 )  {
    $year_list .= "<a href=\"javascript:select('year','$x');\">$x</a><br>\n"

  }

  for ( $x=1; $x < 16; $x = $x + 2 )  {
    $track_list .= "<a href=\"javascript:select('track','$x');\">$x</a><br>\n"

  }

  print inject_vars ( "templates/file.inc",
		"title_list",		$title_list,
		"title_default",	$title_default,
		"artist_list",		$artist_list,
		"artist_default",	$artist_default,
                "album_list",		$album_list,
		"album_default",	$album_default,
		"genre_list",		$genre_list,
		"genre_default",	$genre_default,
		"year_list",		$year_list,
		"year_default",		$year_default,
		"track_list",		$track_list,
		"track_default",	$track_default,
                "path",         	$cgi{'file'} );

}
else  {
  if ( $cgi{'path'} ne "" )  {
    if ( -d $cgi{'path'} )  {
      scan_directory ( $cgi{'path'} );
      $total = @mp3_files;

      if ( $total < 1 )  {
        $message = "no mp3 files off of that directory.";

      }
      else  {
        $message = "found $total mp3 files.";

      }

    }
    else  {
      $message = "not a valid directory.";

    }

  }
  else  {
    $cgi{'path'} = "";
    $message = "enter a filesystem path";

  }

  print inject_vars ( "templates/search_paths.inc", 
		"version",	$version,
		"path",		$cgi{'path'},
		"message",	$message );

  $x = 1;
  foreach $mp3_file ( @mp3_files )  {
    if ( database_is_path_inserted ( $dbh, $mp3_file ) )  {
      print "<tr><td bgcolor=dddddd><font face=arial size=1>$x. [ inserted ] $mp3_file</font></td></tr>\n";

    }
    else  {
      $url = $mp3_file;
      escape_url_comp ( $url );
      print "<tr><td bgcolor=dddddd><font face=arial size=1>$x. [ <a href=javascript:openWindow('search_paths.cgi?file=$url');>insert</a> ] $mp3_file</font></td></tr>\n";

    }
    $x ++

  }

}

print expand_path ( "templates/footer.inc" );

#
# scan_directory ( $directory );
#   a recursive routine that walks a directory tree building
#   an array of mp3 files.
#

sub scan_directory  {
  my $directory = pop @_;
  my @entries;
  my $entry;

  opendir ( D, $directory ) || die "can't open $_: $!\n";
  @entries = readdir ( D );
  closedir ( D );

  foreach $entry ( @entries )  {
    if ( -d "$directory/$entry" )  {
      scan_directory ( "$directory/$entry" ) unless ( $entry =~ /^\./ );

    }
    else {
      if ( $entry =~ /\.mp3$/i )  {
        push @mp3_files, "$directory/$entry";
      }

    }

  }

}

#
# $somthing = capitalize ( $somthing );
#   capitalizes $somthing.
#

sub capitalize  {

  my ( $string ) = @_;

  $string =~ s/.mp3$//;
  $string =~ s/_/ /g;
  $string =~ s/(\W)ii/$1II/g;
  $string =~ s/(\W)im(\W)/$1i'm$1/g;
  $string =~ s/(^\w)/uc $1/eg;
  $string =~ s/( \w)/uc $1/eg;
  $string =~ s/(-\w)/uc $1/eg;

  return $string;

}
